   local old = love.graphics.setColor
   function love.graphics.setColor(arg,two,three,four)
      if two then -- there's 3 or 4 vars
         old(arg/255,two/255,three/255, (four or 255)/255)
      else -- arg is a table
         if arg then
            old(arg[1]/255,arg[2]/255,arg[3]/255, (arg[4] or 255)/255)
         else
            local arg = main
            old(arg[1]/255,arg[2]/255,arg[3]/255, (arg[4] or 255)/255)
         end
      end
   end

   local _old = love.graphics.getColor
   function love.graphics.getColor()
      local ret = {_old()}
      return ret[1]*255,ret[2]*255,ret[3]*255,ret[4]*255
   end

--os.execute("echo off")
--os.execute("@chcp 65001")


local artists={
               {name="Søren \"Shiu\" Nielsen", art="icons", url="https://opengameart.org/content/grayscale-icons"}
              }

local list  = require("liist")
local listr = require("liistr")
local lists = {{name="1500 eng", list = list}, {name="1000 рус", list = listr}}
local clisti = 1
local clist = lists[clisti]
local history = {}
local font = love.graphics.newFont("neucha.ttf", 120)
local f0nt = love.graphics.newFont("neucha.ttf", 72)
local fOnt = love.graphics.newFont("neucha.ttf", 36)
local word = clist.list[1]
local controls_line = "<    ll    >"
local ww,wh = 200,20--font:getWidth(word), font:getHeight(word)
local cw,ch = 200,20--font:getWidth(controls_line ), font:getHeight(controls_line)
local rw1,rh1 = 200,20--f0nt:getWidth("случайно"), f0nt:getHeight("случайно")
local rw2,rh2 = 200,20--f0nt:getWidth("по порядку"), f0nt:getHeight("по порядку")
local time = 0
local waves = {}
local mouse_down
local pause
local history_index = 0
local timelimit = 30
local mode = "game"
local gears = love.graphics.newImage("gears.png")
local flag  = love.graphics.newImage("flag.png")
local cup   = love.graphics.newImage("cup.png")
local identity = "word_list_2018"
local sep = "/"--package.config:sub(1,1)
local save_folder = "lists"
local randommode = true
local lastidx = 1
local list_names = {}
local canvas = love.graphics.newCanvas(8000,600)
local add_list_warning = [[Сюда нужно складывать файлы-словари с любым расширением.
Файл-словарь - это обычный текстовый документ, в котором на каждой строке находится всего одно слово.
Например:

Вася
Петя
Кашалот
Безобразие
До и после

Программе не важно, какие символы будут в "словах", но рекомендуемая длинна строки - 18 знаков.
Иначе слово просто не поместится на экране программы и будет использован шрифт меньшего размера.
Для пользователей ПК это не проблема, а вот на мобильном устройстве текст может оказаться нечитаемым.]]

--local gui = require("gui")
--gui:set_main({020,20,80})
--gui:set_fore({220,220,220})

--------------------------
---------VK part ---------
--local LuaVkApi      = require "LuaVkApi"
--local inspect       = require "inspect"
local app_id        = 5780696
local authorize_url = "https://oauth.vk.com/authorize?client_id=" .. app_id .. "&display=page&redirect_uri=https://oauth.vk.com/blank.html&scope=268435455&response_type=token&v=5.53"
local api_ver       = "5.53"
local access_token = ""

local function get_token()
      print("Получаем токен...")
      local file = io.open("token","r")

      if file then
         print(" - загружен из файла")
         access_token = file:read("*all")
         io.close(file)
      else
         print(" - пожалуйста, зайдите в ВК через браузер и введите полученый токен сюда:")
         open_url(authorize_url)
         access_token = io.read("*line")
         local file = io.open("token","w")
         print("Сохраняем токен на будущее...")
         file:write(access_token)
         file:close()
      end
end

-- Attempts to open a given URL in the system default browser, regardless of Operating System.
local open_cmd -- this needs to stay outside the function, or it'll re-sniff every time...

function open_url(url)
    if not open_cmd then
        if package.config:sub(1,1) == '\\' then -- windows
            open_cmd = function(url)
                -- Should work on anything since (and including) win'95
                print(url)
                os.execute(string.format('start "%s"', url))
            end
        -- the only systems left should understand uname...
        elseif (io.popen("uname -s"):read'*a') == "Darwin" then -- OSX/Darwin ? (I can not test.)
            open_cmd = function(url)
                -- I cannot test, but this should work on modern Macs.
                os.execute(string.format('open "%s"', url))
            end
        else -- that ought to only leave Linux
            open_cmd = function(url)
                -- should work on X-based distros.
                os.execute(string.format('xdg-open "%s"', url))
            end
        end
    end

    open_cmd(url)
end

function url_encode(str)
  if (str) then
    str = string.gsub (str, "\n", "\r\n")
    str = string.gsub (str, "([^%w %-%_%.%~])",
        function (c) return string.format ("%%%02X", c:byte(1, -1)) end)
    str = string.gsub (str, " ", "+")
  end
  return str
end

-------------------------



-- funcitons and preparations
waves[1] = { speed =  5, pos = 800}
waves[2] = { speed = -5, pos = 800}

function update_lists()
    list_names = {}
    local dics = love.filesystem.getDirectoryItems(save_folder)
    for i, file in ipairs(dics) do
        if file ~="readme.txt" then
           local dic = io.open(love.filesystem.getSaveDirectory()..sep..save_folder..sep..file, "r")
           if dic then
              local tmp = {}
              for line in dic:lines() do
                  tmp[#tmp+1] = string.lower(line)
              end
              lists[#lists+1] = {name=file, list = tmp}
           end
        end
    end

    for i=1, #lists do
        list_names[#list_names+1] = lists[i].name
    end
    return list_names
end

love.filesystem.setIdentity(identity)
if not love.filesystem.getInfo(save_folder) then love.filesystem.createDirectory(save_folder) end
file, err = io.open(love.filesystem.getSaveDirectory()..sep..save_folder..sep.."readme.txt", "w")
if not err then
   file:write(add_list_warning)
   file:close()
end



--gui
--local root   = gui.newPanel(0,0,800,600):setParent(gui.root):setText("Настройки","center","top"):setTextOutline(true):show()
--local langl  = gui.newLabel(20,200,120,60):setParent(root):setText("Список"):show()
--local addll  = gui.newLabel(20,300,320,60):setParent(root):setText("Добавить список "):show()
--local timel  = gui.newLabel(20,400,120,60):setParent(root):setText("Таймаут"):show()

--local timene = gui.newPanel(370,410,300,80):setParent(root):setText(timelimit, "center","center"):show()
--local ub2 = gui.newButton(680,410,80,80):setParent(root):setText(">", "center","center"):show()
--local db2 = gui.newButton(280,410,80,80):setParent(root):setText("<", "center","center"):show()
--local addlb  = gui.newButton(680,310,80,80):setParent(root):setText("..."):show()

update_lists()
--local langl = gui.newComboBox(280,210,480,80):setParent(root):setText(lists[clisti].name, "center","center"):show():setItems(list_names)

--local vk_button = gui.newButton(480,510,200, 80):setParent(root):setText("связать с VK","center","center"):show()
--[[
function vk_button.onClick()
   get_token()
   local api = LuaVkApi:new(access_token, api_ver)
   local current_user = api:getUsersInfo(nil,"uid", "nom")
   for k,v in pairs(api:stringToJson(current_user)) do
       print(k,v)
       if type(v)=="table" then
          for kk,vv in pairs(v) do
              print(" ",kk,vv)
          end
       end
   end
   current_user = api:stringToJson(current_user).response[1] -- WHY?!! O_o
   print("Инфа по текущему пользователю:")
   print("+----------------+---------------")
   for k,v in pairs(current_user) do
       local kk = k
       local lk = #k
       for i=1,15-lk do kk = kk.." " end
       print(" " .. kk .. " | " .. tostring(v))
   end
   print("+----------------+---------------")

   local resp = api:stringToJson(api:getMessagesUploadServer()).response
   for k,v in pairs(resp) do
       print(k, v)
   end
   local upload_url = resp.upload_url
   local mp = (require "multipart-post").gen_request
   local H = (require "ssl.https").request
   local filename = "screenie.png"
   local file = io.open(filename, "rb")
   local contents = file:read( "*a" )
   local rq = mp{myfile = {name = filename, data = contents}}
   rq.url = upload_url
   print(upload_url)
   local b,c,h = H(rq)
   print(b,c,inspect(h))




   --local resp = {api:sendMessage(nil,             current_user.id, nil, nil, nil, url_encode("Бредогенератор приветствует тебя!\nВот твоё новое слово:"),nil,nil,nil,"photo26516886_456239455" )}

end


function langl.onSelect(text, index)
   clisti = index
   clist = lists[clisti]
   word = clist.list[1]
end

ub2.onClick = function ()
      timelimit=timelimit+1
      timene:setText(timelimit)
end

ub2.onMouseDown = function ()
   if (ub2.pressed_timer or 0) > 0.5 then
      timelimit=timelimit+1
      if timelimit>math.huge then timelimit = math.huge end
      timene:setText(timelimit)
   end
end

db2.onClick = function ()
      timelimit=timelimit-1
      if timelimit<1 then timelimit = 1 end
      timene:setText(timelimit)
end

db2.onMouseDown = function ()
   if (db2.pressed_timer or 0) > 0.5 then
      timelimit=timelimit-1
      if timelimit<1 then timelimit = 1 end
      timene:setText(timelimit)
   end
end

addlb.onClick = function()
   print(love.system.openURL(love.filesystem.getSaveDirectory()..sep..save_folder))
end

]]
function onClick(x,y)
   if y> h-ch and y< h-ch+120 then
      if x> math.ceil((w-cw)/2)-50 and x < math.ceil((w-cw)/2)-50+170 then
         history_index = history_index - 1
         if history_index < 1 then history_index = 1 end
         if history[history_index] then
            word = history[history_index]
         end
      end

      if x> math.ceil((w-170)/2) and x< math.ceil((w-170)/2) + 170 then
         pause = not pause
      end

      if x> math.ceil((w+cw)/2)-120 and x < math.ceil((w+cw)/2)-120 + 170 then
         time = time + 300
      end
   end

    if x> 0 and x< 128 and y>0 and y<128 then
       if mode == "settings" then
          mode  = "game"
       else
          mode  = "settings"
          pause = true
       end
    end

    if x> math.floor((w-rw1)/2) and x< math.floor((w+rw1)/2) and y>0 and y<10+rw2 then
       randommode = not randommode
    end
end

function love.load(args)
   math.randomseed(os.time())
end

function love.update(dt)
   sin_timer = (sin_timer or 0) + dt
   if love.mouse.isDown(1) then
      if not mouse_down then
         onClick(love.mouse.getPosition())
         mouse_down = true
      end
   else
      mouse_down = false
   end


   if mode == "settings" then
      --gui:update(dt)
      return
   end

   if not pause then
      time = time + dt
   end

   if time > timelimit then
      time = 0
      if not history[history_index+1] then

         -- make a new word
         if randommode then
            -- random always has the next word
            lastidx = math.random(2, #clist.list)
            word = clist.list[lastidx]
            --print("chaos",lastidx, word)
         else
            -- ordered can miss one, since we may hit the end of the current list
            if clist.list[lastidx+1] then
               lastidx = lastidx + 1
               word = clist.list[lastidx]
               --print("order",lastidx, word)
            end
         end
         -- so, regardless, we need to store new word here
         --print('new history', history_index, history[history_index], #history)
         -- костыль:
         if word~=history[#history] then
            history[#history+1] = word
         end
         history_index = #history
      else

         -- here we don't make any new words, but extort those from history
         -- we can't extort anything if there's nothing to extort,
         -- but the check is above.
         -- anyway, here we only move forward in history
         history_index = history_index+1
         word = history[history_index] or "???"
         --print('true history', history_index, history[history_index])
      end
   end
   for i = 1, 2 do
      waves[i].pos = waves[i].pos + waves[i].speed*dt*10
      if waves[i].speed<0 and waves[i].pos <= -800 then waves[i].pos = 800 end
      if waves[i].speed>0 and waves[i].pos >=  800 then waves[i].pos = -800 end
   end
end

function love.draw()
   local mx,my=love.mouse.getPosition()

   if mode == "settings" then
      --gui:draw(0,0)
      if mx<128 and my<128 then
         love.graphics.setColor(255,255,155)
      else
        love.graphics.setColor(255,255,155, 100)
      end
      love.graphics.draw(cup, 0, 0)
      return
   end

   w,h = love.graphics.getDimensions()
   ww,wh = font:getWidth(word), font:getHeight(word)
   tw,th = f0nt:getWidth(math.floor(timelimit-math.floor(time))), f0nt:getHeight(math.floor(time))
   love.graphics.setFont(font)
   love.graphics.setLineWidth(1)

   love.graphics.setColor(0,0,180,80)
   love.graphics.rectangle("fill", 0,0, 800, 155)
   love.graphics.rectangle("fill", 0,h-255, 800, 250)
   love.graphics.setColor(255,255,255)

   for i = -800, 800 do

       love.graphics.push()
       love.graphics.translate(-800,0)
       love.graphics.line(waves[1].pos+(i-5)*10, math.sin(i-5+time % 5)*10+ 150, waves[1].pos+(i)*10, math.sin(i+time % 5)*10+ 150)
       love.graphics.setColor(180,180,180,80)
       love.graphics.line(waves[2].pos+(i-5)*10, math.sin(i-5+time % 5)*10-20, waves[2].pos+(i-10)*10, math.sin(i-10+time % 5)*10+ 150)
       love.graphics.setColor(255,255,255)
       love.graphics.pop()

       love.graphics.push()
       love.graphics.translate(-800,0)
       love.graphics.line(waves[2].pos+(i-5)*10, math.sin(i-5+time % 5)*10+ h - 250, waves[2].pos+(i)*10, math.sin(i+time % 5)*10 + h - 250)
       love.graphics.setColor(180,180,180,80)
       love.graphics.line(waves[1].pos+(i-5)*10, math.sin(i-5+time % 5)*10+h-250, waves[1].pos+(i-10)*10, math.sin(i-10+time % 5)*10+ h)
       love.graphics.setColor(255,255,255)
       love.graphics.pop()

   end


   local w_scale
   if ww>w then
      --local f0nt = love.graphics.newFont("neucha.ttf", 72)
      --local fOnt = love.graphics.newFont("neucha.ttf", 36)
      love.graphics.setFont(f0nt)
      ww,wh = f0nt:getWidth(word), f0nt:getHeight(word)
      if ww>w then
         love.graphics.setFont(fOnt)
         ww,wh = fOnt:getWidth(word), fOnt:getHeight(word)
      end
   end

 --  love.graphics.pretty_print(word, math.ceil((w-ww)/2), math.ceil((h-wh)/2)-60, 2,c, sho,ad, nil, {255,200,155,58})
   love.graphics.print(word, math.ceil((w-ww)/2), math.ceil((h-wh)/2)-60)

   love.graphics.setFont(font)

   love.graphics.setLineWidth(6)
   love.graphics.setColor(35, 35,55)
   love.graphics.rectangle("fill",math.ceil((w-cw)/2)-50, h-ch, 170, 120,  10)
   if pause then love.graphics.setColor(125, 125,155) end
   love.graphics.rectangle("fill",math.ceil((w-170)/2), h-ch, 170, 120,  10)
   love.graphics.setColor(35, 35, 55)
   love.graphics.rectangle("fill",math.ceil((w+cw)/2)-120, h-ch, 170, 120,  10)

   love.graphics.setColor(255,255,255)
   love.graphics.rectangle("line",math.ceil((w-cw)/2)-50, h-ch, 170, 120,  10)
   love.graphics.rectangle("line",math.ceil((w-170)/2), h-ch, 170, 120,  10)
   love.graphics.rectangle("line",math.ceil((w+cw)/2)-120, h-ch, 170, 120,  10)

   love.graphics.print(controls_line, math.ceil((w-cw)/2), h-ch - 20)

   love.graphics.setFont(f0nt)
   love.graphics.setColor(255,255,155)
   if time < timelimit then
      love.graphics.print(timelimit-math.floor(time), w-tw-10,10)
   end

   if mx<128 and my<128 then
      love.graphics.setColor(255,255,155)
   else
     love.graphics.setColor(255,255,155, 100)
   end
   love.graphics.draw(gears, 0, 0)

   love.graphics.setColor(255,200,155)
   love.graphics.setFont(f0nt)
   if randommode then
      love.graphics.print("случайно", math.floor((w-rw1)/2),10)
   else
      love.graphics.print("по порядку", math.floor((w-rw2)/2),10)
   end
end

--gui:setScale(0.7)
